#pragma once

#include "../core.h"
#include "../classes/application.h"

Window* Application::win;

void Application::setWindow(Window* wnd) {
	win = wnd;
}

Window* Application::getWindow() {
	return win;
}

void Application::waitForEvent() {
	int k_event, i;

	Window* win = getWindow();

	while(k_event=kos_WaitForEvent()) {
		for (i=0;i<MAX_FORM_CONTROLS;i++) {
			if (win->controls[i]) win->controls[i]->sysevent(k_event);
		}

		switch (k_event) {
			case EM_WINDOW_REDRAW:
				win->draw();
			break;
			case EM_KEY_PRESS:
				Byte keyCode;
				kos_GetKey(keyCode);
				win->lastKeyPressCode = keyCode;

				win->call(EVENT_KEY_PRESS);
			break;
			case 3:
				Dword buttonId;
				kos_GetButtonID(buttonId);
				
				win->clickButtonId = (int)buttonId;

				Button* button = win->getButton(buttonId);
				if (button) {
					button->call(EVENT_BUTTON_CLICK);
					button->onClick();
				}

				if (buttonId == 1) {
					win->call(EVENT_WINDOW_CLOSE);
					return Application::exit();
				}

			break;
		}
	}
}

void Application::run() {
	Window* win = getWindow();
	win->init();
	//  
	win->draw();
	//   

	waitForEvent();
}

void Application::exit() {
	delete win;
	__asm or eax, -1
	__asm int 0x40
}