#include "../core.h"
#include "../modules/pixels.h"

Pixels::Pixels(int sizeX=10, int sizeY=0, Dword color=COLOR_GREEN) {
	this->x = 0;
	this->y = 0;
	this->sizeX = sizeX;
	this->sizeY = sizeY;
	this->color = color;
	
	this->defColor = color;

	this->id = 0;

	this->map = new int*[sizeY];

	int i,j;
	for (i=0;i<sizeY;i++) {
		this->map[i] = new int[sizeX];
		for (j=0;j<sizeX;j++) {
			this->map[i][j] = color;
		}
	}
}

void Pixels::draw() {
	this->call(EVENT_DRAW);
	int y,x, pxColor;

	for (y=0;y<sizeY;y++) {
		for (x=0;x<sizeX;x++) {
			pxColor = this->map[y][x];
			this->drawPixel(x,y,(Dword)pxColor);
		}
	}
}

void Pixels::updateMap() {
	int y,x, pxColor;

	delete[] this->map;
	this->map = new int*[this->sizeY];

	for (y=0;y<sizeY;y++) {
		this->map[y] = new int[sizeX];
		for (x=0;x<sizeX;x++) {
			this->map[y][x] = this->color;
		}
	}

	this->defColor = this->color;
}

void Pixels::SetPixelColor(int x, int y, Dword pxColor) {
	this->map[y][x] = pxColor;
}

int Pixels::getType() {
	return CONTROL_PIXELS;
}

int Pixels::getId() {
	return this->id;
}

//  1  
void Pixels::drawPixel(Dword x, Dword y, Dword pxColor) {
	x += this->x;
	y += this->y;

	//Dword pxColor = (Dword)this->color;

	__asm{
		push 1
		pop eax
		mov ebx, x
		mov ecx, y
		mov edx, pxColor
		int 0x40
	}
}